/*
 * vitezometru.c
 *
 * Created: 19.05.2013 19:05:10
 *  Author: Serban
 */ 


#include <avr\io.h>
#include <avr\interrupt.h>
#define F_CPU 16000000
#include <util/delay.h>

#include <string.h>
#include <stdio.h>

#include "lcd.h"

int  global = 0;
int speed	= 0;
float wheel = 2;
int passes	= 0;
char aux[16];
char msg2[16];

ISR(TIMER1_COMPA_vect) 
{
	++global;
	if (global == 30)
		speed = 0;
	LCD_writeInstruction(LCD_INSTR_clearDisplay);
	sprintf(aux, "treceri: %d", passes);
	sprintf(msg2, "Speed: %d km/h", speed);
	LCD_print2(aux, msg2);
	//PORTD ^= ( 1 << PD7);
}

ISR(PCINT2_vect)
{

	//PORTD ^= (1 << PD7);
	//_delay_ms(500);
	if ((PINC & (1<<PC7)) == 0) {
	++passes;
	speed = 10 / global * 3600 / 1000 * wheel;
	global = 0;
	}
	//_delay_ms(5000);
}


/* Afisare mesaj simplu */
void init_transmission()
{	
	DDRD 	|= (1 << PD7);			// set PD7 as output
	
	DDRD 	&= ~(1 << PD6);  		// pin PD6 as input
	PORTD 	|= (1 << PD6);  		// activate pull-up
	
	DDRD 	|= (1 << PD5);			// set PD5 as output
	PORTD 	|= (1 << PD5);			// set PD5 on 1
	
	DDRC 	&= ~(1 << PC7);			// set PC7 as input
	PORTC 	|= (1 << PC7);			// activate pull up resistor
	
	PCICR 	|= (1 << PCIE3);		// enable interrupts on PCINT24:31 => PCIE3
	PCICR 	|= (1 << PCIE2);		// enable interrupts on PCINT16:23 => PCIE2
	//PCMSK3 	|= (1 << PCINT30);		// enable interrupt for pin PD6 (INT30)
	PCMSK2 	|= (1 << PCINT23);		// enable interrupt for pin PC7 (INT23)
	
	sei();		// enable global interrupts
	
	// init the counter/timer1 (16 bit)
	TIMSK1 |= (1 << OCIE1A);	// enable interrupt on OCR1A
	TCCR1A |= (1 << COM1B0);	// what to toggle on compare match
	TCCR1B |= (1 << WGM12);		// CTC
	TCCR1B |= (1 << CS12);		// prescaler 256
	OCR1A 	= 6250;				// units to count
	
	// init timer 0 (8 bit)
	//TIMSK0 |= (1 << OCIE0A);	// enable interrupt on OCR0A
	//TCCR0A |= (1 << COM0B0);
	//TCCR0B |= (1 << WGM02);	// toggle OC0A on match
	//OCR0A 	= 208;				// units to count
}

int main()
{	
	
	init_transmission();
	LCD_init();		// init LCD
	
	_delay_ms(1000);
	
	
	
	
	while(1);
	
	return 0;
}
